// Copyright (c) 2018 WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
//
// WSO2 Inc. licenses this file to you under the Apache License,
// Version 2.0 (the "License"); you may not use this file except
// in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

import ballerina/http;
import ballerina/io;
import ballerina/log;

service onTextString on new http:WebSocketListener(9080) {

    resource function onText(http:WebSocketCaller caller, string data, boolean finalFrame) {
        var returnVal = caller->pushText(data);
        if (returnVal is error) {
             panic returnVal;
        }
    }
}

service onTextJSON on new http:WebSocketListener(9081) {

resource function onText(http:WebSocketCaller caller, json data) {
        var returnVal = caller->pushText(data);
        if (returnVal is error) {
             panic returnVal;
        }
    }
}

service onTextXML on new http:WebSocketListener(9082) {

    resource function onText(http:WebSocketCaller caller, xml data) {
        var returnVal = caller->pushText(data);
        if (returnVal is error) {
             panic returnVal;
        }
    }
}

type Person record {
    int id;
    string name;
    !...
};
service onTextRecord on new http:WebSocketListener(9083) {

    resource function onText(http:WebSocketCaller caller, Person data) {
        var personData = json.convert(data);
        if (personData is error) {
             panic personData;
        } else {
             var returnVal = caller->pushText(personData);
             if (returnVal is error) {
                  panic returnVal;
             }
        }
    }
}

service onTextByteArray on new http:WebSocketListener(9084){

    resource function onText(http:WebSocketCaller caller, byte[] data) {
        var returnVal = caller->pushText(data);
        if (returnVal is error) {
             panic returnVal;
        }
    }
}
