// Copyright (c) 2018, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
//
// WSO2 Inc. licenses this file to you under the Apache License,
// Version 2.0 (the "License"); you may not use this file except
// in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.





// remote modifier not allowed in non-object attached functions
remote function test1(string value) {
}

// remote modifier not allowed in non-object attached functions
public remote function test2(string value) {
}

// remote modifier not allowed in non-object attached functions
public remote extern function test3(string value) returns int;


type Foo client object {

    function abc (string value) returns int;

    remote function pqr(string value) returns boolean {
        return false;
    }

    remote function xyz (string value) returns float;
};

// attempt to refer non-remote function as remote
remote function Foo.abc (string value) returns int {
    return 10;
}

// remote modifier required here
function Foo.xyz (string value) returns float {
    return 10.0;
}

function testFunc1() {
    Foo x = new;
    // invalid remote function invocation syntax, use '->' operator
    var y = x.pqr("test");
    // undefined remote function 'abc' in endpoint Foo
    var z = x->abc("test");
}


function testFunc2() {
    // Testing other type invocation.
    XXX x = new;
    // invalid remote function invocation, expected an endpoint
    var y = x->foo();

    map<any> m = {};
    // invalid remote function invocation, expected an endpoint
    _ = m->keys();

    Bar b = new;
    // invalid remote function invocation, expected an endpoint
    _ = b->action1("value");
}

type Bar object {
   function action1 (string x) returns int {
       return 10;
   }
};

function testFunc3() {
    Bar b = new;
    int i = 10;
    if(i > 5) {
        // endpoint declaration not allowed here, declare at the top of a function or at module level
        Foo x = new;
        var y = x->pqr("test");
    }
}

function testFunc4() {
    worker w1{
        // endpoint declaration not allowed here, declare at the top of a function or at module level
        Foo x = new;
        var y = x->pqr("test");
    }
    worker w2 {
        int i = 10;
    }
}

// valid.
Foo gep = new;

function testFunc5() {
    var y = gep->pqr("test");

    // invalid remote function invocation syntax, use '->' operator
    var z = gep.pqr("test");
}


function testFunc6(Foo ep, string b) {
    var y = ep->pqr("test");

    // invalid remote function invocation syntax, use '->' operator
    var z = ep.pqr("test");
}

function testFunc7 (string s) {
    string a = "abc";
    // endpoint declaration not allowed here, declare at the top of a function or at module level
    Foo ep = new;
    var y = ep->pqr("test");
}

function testFunc8 (string s) {
    Foo ep;
    string a = "abc";
    // endpoint declaration not allowed here, declare at the top of a function or at module level
    Foo ep2 = new;
    var y = ep2->pqr("test");
}

function testFunc9 (string s) returns boolean{
    Foo ep;
    string a = "abc";
    // Uninitilized variable
    return ep->pqr("test");
}

function testFunc10 (string s) {
    Foo ep;
    string a = "abc";
    // Uninitilized variable
    var y = ep->pqr("test");
}

type Baz object {
    //a remote function in a non client object
    remote function action1(string s) returns int {
        return 10;
    }

    function nonAction(float f) returns string {
        return "done";
    }

    //a remote function in a non client object
    remote function action2(int i) {
    }
};

// client objects requires at least one remote function
type Bax client object {

    function nonAction1(float f) returns string {
        return "done";
    }

    function nonAction2(float f) returns string {
        return "done";
    }
};

type dummy object {

    Foo ff = new;

    function nonAction1(float f) returns string {
        _ = self.ff->pqr("test");
        return "done";
    }

};
